// OSCCON(Oscillator Control Register)̗p̐ݒ

// SPLLEN(PLL̗p̗Lݒ)
//	#define SPLLEN_4xPLL_en   0b1		// 4~PLL Enabled
										//  IRCF8MHzƑgݍ킹FOSC = 32MHzɐݒłD
//	#define SPLLEN_4xPLL_dis  0b0		// 4~PLL Disabled
// RtBM[Vݒ PLLEN_ONł΁CSPLLEN̒lɂ炸4~PLL͏ONłD


	// IRCF(IV[^̔Mgݒ)
	#define 	Int_OSC_Freq_16MHz 	0b1111		
	#define 	Int_OSC_Freq_8MHz  	0b1110
	#define 	Int_OSC_Freq_4MHz  	0b1101
	#define 	Int_OSC_Freq_2MHz  	0b1100
	#define 	Int_OSC_Freq_1MHz  	0b1011
	#define 	Int_OSC_Freq_500kHz 0b1010
	
	// SCS(VXeNbN(FOSC)ɂǂ̃NbN𗘗p邩ݒ肷D)
	#define SysClockSource_int_OSC_block 	0b11    // IV[^ubN̏o͂pD
				            		// IRCFWX^Őݒ肵lFOSCƂȂD
	#define SysClockSource_32_768kHz        0b01    // T1OSI(2ԃs), T1OSOs(3ԃsj32.768kHz
				            		// UڑāC̏o͂pD
	#define SysClockSource_detmd_by_Config 	0b00	//RtBM[VݒFOSC_XXPLLEN_xx̐ݒɏ]D


//֐̐錾
void set_osc(unsigned int x,unsigned int y);


// T1CON(Timer1 Control Register)̗p̐ݒ

	// TMR1CS(^C}1̃NbN\[Xݒ肷)
	#define TMR1_clock_source_CPSOSC 	0b11	// Capacitive sensing oscillator̃NbN𗘗pD
	#define TMR1_clock_source_T1Ck_T1OS 0b10	// ONbN(T1CK0jor T1OSI/T1OSO͂𗘗pD
	#define TMR1_clock_source_FOSC    	0b01	// VXeNbN(FOSC)𗘗pD
	#define TMR1_clock_source_FOSC_1_4  0b00	// VXeNbN(FOSC/4)𗘗pD

	// T1CKPS(^C}1ɓNbN̕ݒ肷D) 
	#define T1Clock_PreScale_1_8    0b11	// 1/8ɂD
	#define T1Clock_PreScale_1_4    0b10	// 1/4ɂD
	#define T1Clock_PreScale_1_2    0b01	// 1/2ɂD
	#define T1Clock_PreScale_1_1    0b00	// 1/1ɂD


	// TMR1ON(^C}P̃I^ItݒD)
	#define TMR1_ON    0b1
	#define TMR1_OFF   0b0
	
 	//̗̑p̓ftHgݒŖ{̎gɖ֌WȂ̂ŁCȗDj

//֐̐錾
void set_timer1_count_down_ini_num(unsigned int i);
void clear_interrupt_flag_of_timer1(void);
void set_timer1(unsigned int a,unsigned int b, unsigned int c);
void set_interrupt_by_timer1(void);



// ADCON0(A/D Control Register 0)̗p̐ݒ

	// CHS(Analog Channel Select bits)
	#define select_AN0	0b00000		//AN0I
	#define select_AN1	0b00001		//AN1
	#define select_AN2	0b00010		//AN2
	#define select_AN3	0b00011		//AN3
	#define select_AN4	0b00100		//AN4
	#define select_AN5	0b00101		//AN5
	#define select_AN6	0b00110		//AN6
	#define select_AN7	0b00111		//AN7

	// ADON(A/D Conversion Enable bit)
	#define AD_ON		0b1		//A/DRo[^IƂ
	#define AD_OFF		0b0		//@@@@@@@ It


// ADCON1(A/D Control Register 1)̗p̐ݒ

	// ADFM(A/D Result Format Select bit)
	#define right_justified	0b1		//ϊʂ16rbgWX^̉E悹Ŋi[D
	#define left_justified	0b0		//@@@@@@@              悹

	// ADCS(A/C Conversion Clock Select bits)
	#define clock_1_2	0b000		// A/DRo[^̃NbNFOSC/2ƂD
	#define clock_1_8	0b001		// @@@@@@@@@@@ FOSC/8
	#define clock_1_32	0b010		//@@@@@@@@@@@@FOSC/32
	#define clock_FRC	0b011		// RCIV[^̃NbNgD
	#define clock_1_4	0b100		//                        FOSC/4
	#define clock_1_16	0b101		//                        FOSC/16
	#define clock_1_64	0b110		//                        FOSC/64
	#define clock_FRC1	0b111		// RCIV[^̃NbNgD

	// ADNREF(A/D Negative Voltage Reference Configuration bit)
	#define neg_ref_VSS         0b0		// A/DRo[^̊d́|VSSƂD
	#define neg_ref_exVREF_Neg  0b1		//             @@@@@@@@ OVREF-sƂ


	// ADPREF(A/D Positive Voltage Reference Configuration bit)
	#define pos_ref_VDD	0b00		// A/DRo[^̊d+VDDƂD
	#define pos_ref_exVREF_Pos 0b10	//                             OVREF+sƂ
	#define pos_ref_FVR	0b11		// dFVR(Fixed Voltage Reference)̓dgp


// FVRCON(Fixed Voltage Reference Control Register)̐ݒ

	// FVREN(FVR Enable bit)
	#define FVR_OFF		0b0		// FVR It
	#define FVR_ON		0b1		// FVR I

	// ADFVR(FVR setting for AD Converter)
	#define ad_ref_OFF      0b00		// FVRɂdItƂD
	#define ad_ref_1_024	0b01		// FVRɂd1.024 [V]ɐݒ
	#define ad_ref_2_048	0b10		//                    2.048 [V]
	#define ad_ref_4_096	0b11		//                    4.096 [V]

//֐̐錾
void set_AD_Converter(unsigned int a, unsigned int b, unsigned int c, unsigned int d, unsigned int e, unsigned int f);
void set_FVR(unsigned int a, unsigned int b);
void start_ad_conversion(void);
unsigned int read_result_of_ad_conversion(void);
void start_ad_conversion_ch_select(unsigned int a);


// CCP2CON(CCP2 Control Register)̐ݒ

	// P2M (Enhanced PWM Output Configuration bits)
	// CCP2M = 11xx̂Ƃ
	#define PWM_with_P2A_only           0b00	// P2ÂPWMóCP2B, P2C, P2D̓|[gs
	#define Full_Bridge_with_P2D		0b01	// tubWPWM, P2A͏펞ICP2DPWMD
	#define Half_Bridge_with_P2A_P2B	0b10	// n[tubWPWM, P2A, P2BPWMóCP2C, P2D̓|[gs
	#define Full_Bridge_with_P2B		0b11	// tubWPWM, P2BPWMCP2C펞I

	// CCP2M (Enhanced CCP2 Mode Select bits)
	#define P2A_B_C_D_active_high		0b1100	// PWM[hCP2A, B, C, D _
	#define P2AC_act_high_P2BD_act_low 	0b1101	//            P2A, C_CP2BD_
	#define P2AC_act_low_P2BD_act_high 	0b1110	//            P2A, C_CP2BD_
	#define P2AC_act_low_P2BD_act_low  	0b1111	// PWM[hCP2A, B, C, D _


// APFCON1(Alternate Pin Function Control Register1)̐ݒ

	// P2BSEL (P2B pin selection bit)
	#define P2B_to_RC2		0b0	// P2BRC2Ɋ蓖Ă
	#define P2B_to_RA4		0b1	// P2BRA4Ɋ蓖Ă

	// CCP2SEL (P2A pin selection bit)
	#define P2A_to_RC3		0b0	// P2ARC3Ɋ蓖Ă
	#define P2A_to_RA5		0b1	// P2BARA5Ɋ蓖Ă


// CCPTMRS(PWM Timer Selection Control Register0)̐ݒ
	
	// C2TSEL (CCP2 Timer Selection bits)
	#define based_on_timer2		0b00	// ^C}2ɂPWM
	#define based_on_timer4		0b01	// ^C}4ɂPWM
	#define based_on_timer6		0b10	// ^C}6ɂPWM 


// PWM2CON (Enhanced PWM Control Register)̐ݒ

	// P2DC (PWM Delay Count bits)
	#define _125ns   0b0000001	// fbh^C@125 [ns]
	#define _250ns   0b0000010	// 		 250 [ns]	
	#define _375ns   0b0000011	// 		 375 [ns]
	#define _500ns   0b0000100	// 		 500 [ns]


// T2CON (Timer2 Control Register)̐ݒ

	// T2OUTPS (Timer2 Output Postscaler Select bits)
	#define set_Postscaler_1_1		0b0000 	// 1:1Ƀ^C}2o͂𕪎
	#define set_Postscaler_1_2		0b0001 	// 1:2Ƀ^C}2o͂𕪎
	#define set_Postscaler_1_3		0b0010 	// 1:3Ƀ^C}2o͂𕪎
	#define set_Postscaler_1_4		0b0011 	// 1:4Ƀ^C}2o͂𕪎
	#define set_Postscaler_1_5		0b0100 	// 1:5Ƀ^C}2o͂𕪎
	#define set_Postscaler_1_6		0b0101 	// 1:6Ƀ^C}2o͂𕪎
	#define set_Postscaler_1_7		0b0110 	// 1:7Ƀ^C}2o͂𕪎
	#define set_Postscaler_1_8		0b0111 	// 1:8Ƀ^C}2o͂𕪎
	#define set_Postscaler_1_9		0b1000 	// 1:9Ƀ^C}2o͂𕪎
	#define set_Postscaler_1_10		0b1001 	// 1:10Ƀ^C}2o͂𕪎
	#define set_Postscaler_1_11		0b1010 	// 1:11Ƀ^C}2o͂𕪎
	#define set_Postscaler_1_12		0b1011 	// 1:12Ƀ^C}2o͂𕪎
	#define set_Postscaler_1_13		0b1100 	// 1:13Ƀ^C}2o͂𕪎
	#define set_Postscaler_1_14		0b1101 	// 1:14Ƀ^C}2o͂𕪎
	#define set_Postscaler_1_15		0b1110 	// 1:15Ƀ^C}2o͂𕪎
	#define set_Postscaler_1_16		0b1111 	// 1:16Ƀ^C}2o͂𕪎

	// TMR2ON (Timer2 On bit)
	#define timer2_on		0b1	// ^C}2IƂD
	#define timer2_off		0b0	// ^C}2ItƂD

	// T2CKPS (Timer2 Clock Prescale Select bits)
	#define set_Prescaler_1_1		0b00	// 1:1Ƀ^C}2͂𕪎
	#define set_Prescaler_1_4		0b01	// 1:4Ƀ^C}2͂𕪎
	#define set_Prescaler_1_16		0b10	// 1:16Ƀ^C}2͂𕪎
	#define set_Prescaler_1_64		0b11	// 1:64Ƀ^C}2͂𕪎

//֐̐錾
void set_PWM(unsigned int a, unsigned int b, unsigned int c, unsigned int d, unsigned int e);
void set_PWM_duty_cycle(unsigned long int a);
void set_PWM_dead_time(unsigned long int a);
void set_timer2(unsigned int a, unsigned int b, unsigned int c, unsigned int d);
void set_interrupt_by_timer2(void);
void clear_interrupt_flag_of_timer2(void);


void PI_controller(void);